// generated 2005/1/6 10:23:47 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to ConfigView.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "ConfigView.hh"
#include "MainWindow.hh"
#include "SystemService.h"

#include "gettext.h"

extern MgeUtils *pspUtils; // FIXME: not clean
extern Glib::ustring *pspCmd; // FIXME: not clean

ConfigView::ConfigView(NutConfig *nutCfgClass, int baseUserMode)
  :View("config")
{
  nutConfig = nutCfgClass;

  // Blank all entries to remove "dummy"
  sdTimerValue->set_text(""); 
  sdBattLevelValue->set_text("");
  sdRuntimeValue->set_text("");
  customSdCommand->set_text("");
  SdDurationValue->set_text("");

  // Blank rbShutdown* for standard user
  rbNoShutdown->set_active(false);
  rbShutdown->set_active(false);
  rbCustomShutdown->set_active(false);

  // Values init
  changesToCommit = false;
  needServiceRestart = false;

  // Final beautification
  // --------------------
  // Entries alignment
  sdTimerValue->set_alignment (Gtk::ALIGN_RIGHT);
  sdBattLevelValue->set_alignment (Gtk::ALIGN_RIGHT);
  sdRuntimeValue->set_alignment (Gtk::ALIGN_RIGHT);

  // Restore configuration values
  restoreConfig();

  // Disable the Save button  (not a real change!)
  btSaveCfg->set_sensitive(false);

  // Enable changeability upon the current user
  setUserMode(baseUserMode);

  refreshView();
}

bool ConfigView::refreshView()
{
  //  show_all_children();
  restoreConfig();

  return true;
}

// Restore values from config files
bool ConfigView::restoreConfig()
{
  std::ostringstream oss; 

	// Special for post first time init:
	// if *all* shutdown criteria are -1
	// then retrieve battery.charge.low as
	// the default
	if ( (nutConfig->getShutdownTimer() == -1)
		&& (nutConfig->getShutdownBatteryLevel() == -1)
		&& (nutConfig->getShutdownBatteryRuntime() == -1) )
	{
		std::cout << "****************** TEST ******************" << std::endl;

		if (mainWinPtr->nutDlg != NULL)
		{
			std::cout << "LOWBATT-CFG (nutClient) = "<< mainWinPtr->nutDlg->nutClient->batteryLowCharge << std::endl;
			nutConfig->setShutdownBatteryLevel(mainWinPtr->nutDlg->nutClient->batteryLowCharge);
		}
	}

  // Restore "Shutdown when timer reaches"
  if (nutConfig->getShutdownTimer() != -1)
 	{
 	  oss << nutConfig->getShutdownTimer();
	  sdTimerValue->set_text(oss.str());
 	  oss.str("");
 	  // Activate the according CheckButton and Entry
 	  ckbtSdTimer->set_active();
 	}
  
  // Restore "Shutdown when battery charge level below"
  if (nutConfig->getShutdownBatteryLevel() != -1)
	{
	  oss << nutConfig->getShutdownBatteryLevel();
	  sdBattLevelValue->set_text(oss.str());
	  oss.str("");
	  // Activate the according CheckButton and Entry
	  ckbtBattLevel->set_active();
	}

  // Restore "Shutdown when remaining backup time below"
  if (nutConfig->getShutdownBatteryRuntime() != -1)
	{
	  oss << nutConfig->getShutdownBatteryRuntime();
	  sdRuntimeValue->set_text(oss.str());
	  oss.str("");
	  // Activate the according CheckButton and Entry
	  ckbtSdRuntime->set_active();
	} 

  // Restore shutdown parameters
  switch (nutConfig->getShutdownType())
	{
	case NutConfig::SD_NONE:
	  rbNoShutdown->set_active(true);
	  break;
	case NutConfig::SD_STANDARD:
	  rbShutdown->set_active(true);
	  break;
	case NutConfig::SD_CUSTOM:
	  rbCustomShutdown->set_active(true);
	  customSdCommand->set_text(*nutConfig->getCustomShutdownCommand());
	  lblCustomCmd->set_sensitive(true);
	  customSdCommand->set_sensitive(true);
	  break;
	default:
	  rbNoShutdown->set_inconsistent();
	  rbShutdown->set_inconsistent();
	  rbCustomShutdown->set_inconsistent();
	}

  // Restore "Display the application icon in the task bar."
  ckbtIconDisplay->set_active(nutConfig->getDisplaySystray());

}

void ConfigView::on_sdTimerValue_changed()
{  
  // Enable the Save button upon change
  // FIXME: check if there are _real_ changes!
  if ((ckbtSdTimer->get_active() == true) &&
	  (sdTimerValue->get_text().empty () == false))
	{
	  btSaveCfg->set_sensitive(true); 
	  changesToCommit = true;
	}
}

void ConfigView::on_sdTimerValue_editing_done()
{
  std::cout << "on_sdTimerValue_editing_done()" << std::endl;
}

void ConfigView::on_sdBattLevelValue_changed()
{  
  // Enable the Save button upon change
  // FIXME: check if there are _real_ changes!
  if ((ckbtBattLevel->get_active() == true) &&
	  (sdBattLevelValue->get_text().empty () == false))
	{
	  btSaveCfg->set_sensitive(true); 
	  changesToCommit = true;
	}
}

void ConfigView::on_sdRuntimeValue_changed()
{  
  // FIXME: TBI

  // Enable the Save button upon change
  // FIXME: check if there are _real_ changes!
  if ((ckbtSdRuntime->get_active() == true) &&
	  (sdRuntimeValue->get_text().empty () == false))
	// FIXME: check value range
	{
	  btSaveCfg->set_sensitive(true); 
	  changesToCommit = true;
	}
}

void ConfigView::on_ckbtSdTimer_toggled()
{  
  sdTimerValue->set_sensitive(ckbtSdTimer->get_active());

  // invalidate value case
  if (ckbtSdTimer->get_active() == false)
		btSaveCfg->set_sensitive(true);
}

void ConfigView::on_ckbtBattLevel_toggled()
{  
  sdBattLevelValue->set_sensitive(ckbtBattLevel->get_active());
  
  // invalidate value case 
  if (ckbtBattLevel->get_active() == false)
		btSaveCfg->set_sensitive(true); 
}

void ConfigView::on_ckbtSdRuntime_toggled()
{   
  sdRuntimeValue->set_sensitive(ckbtSdRuntime->get_active());
  
  // invalidate value case
  if (ckbtSdRuntime->get_active() == false)
		btSaveCfg->set_sensitive(true); 
}

void ConfigView::on_rbShutdown_toggled()
{
  int newSdType;

  // Check which option is active
  if (rbNoShutdown->get_active () == true)
	newSdType = NutConfig::SD_NONE;
  else
	{
	  if (rbShutdown->get_active () == true)
		newSdType = NutConfig::SD_STANDARD;
	}

  if (newSdType != nutConfig->getShutdownType())
	{
	  needServiceRestart = true;
	  nutConfig->setShutdownType(newSdType);
	}

  // Activate the save button
  btSaveCfg->set_sensitive(true);
}

void ConfigView::on_rbCustomShutdown_toggled()
{
  int newSdType = NutConfig::SD_CUSTOM;

  if (newSdType != nutConfig->getShutdownType())
	{
	  needServiceRestart = true;
	  nutConfig->setShutdownType(newSdType);
	}

  lblCustomCmd->set_sensitive(rbCustomShutdown->get_active());
  customSdCommand->set_sensitive(rbCustomShutdown->get_active());
  //btSaveCfg->set_sensitive(true); 
}

void ConfigView::on_customSdCommand_changed()
{
  // Enable the Save button upon _real_ change
  if ((rbCustomShutdown->get_active() == true) &&
	  (customSdCommand->get_text().empty () == false))
	// FIXME: check the entered command (?!)
	{
	  btSaveCfg->set_sensitive(true); 
	  changesToCommit = true;
	}
}

void ConfigView::finalizeSaveCfg()
{
  // Toggle back the Save button
  btSaveCfg->set_sensitive(false);

  changesToCommit = false;

  // Restore the default mouse cursor
  mainWinPtr->get_window()->set_cursor (Gdk::Cursor());

  // Reaffect the settings according to what has
  // been really stored (ie change "12" to "12")
  refreshView();
}

void ConfigView::on_btSaveCfg_released()
{
  int newValue;

  // Set "working" mouse cursor
  mainWinPtr->get_window()->set_cursor (Gdk::Cursor(Gdk::WATCH));

  //Force the GUI to update:
  while(Gtk::Main::events_pending())
	Gtk::Main::iteration();

  // Check "Shutdown when timer reaches"
  newValue = atoi(sdTimerValue->get_text().c_str());
  if ( (ckbtSdTimer->get_active() == true) &&
	   (sdTimerValue->get_text().empty () == false) )
	{
	  // Check bounds
	  if ( (newValue >= 0) && (newValue <= 999999) )
		nutConfig->setShutdownTimer(newValue);
	  else
		{
		  // pspUtils->displayInfoDialog("Shutdown timer value\nmust be between 0 and 999999");
		  pspUtils->displayInfoDialog(_("Shutdown timer value\nmust be between 0 and 999999"));
		  // don't check the rest and return
		  finalizeSaveCfg();
		  return;
		}
	}
  else
		nutConfig->setShutdownTimer(-1);

  // Check "Shutdown when battery charge level below"
  newValue = atoi(sdBattLevelValue->get_text().c_str());
  if ((ckbtBattLevel->get_active() == true) &&
	  (sdBattLevelValue->get_text().empty () == false))
	{
	  // Check bounds
	  if ( (newValue >= mainWinPtr->nutDlg->nutClient->batteryLowCharge)
		   && (newValue <= 100) )
		nutConfig->setShutdownBatteryLevel(newValue);
	  else
		{
		  // FIXME: deal with value < battery.charge.low
		  std::ostringstream oss; 
		  oss << _("Battery charge level value\nmust be between ") << mainWinPtr->nutDlg->nutClient->batteryLowCharge << _(" and 100"); 
		  pspUtils->displayInfoDialog(oss.str());
		  // don't check the rest and return
		  finalizeSaveCfg();
		  return;
		}
	}
  else
		nutConfig->setShutdownBatteryLevel(-1);

  // Check "Shutdown when remaining backup time below"
  newValue = atoi(sdRuntimeValue->get_text().c_str());
  if ((ckbtSdRuntime->get_active() == true) &&
	  (sdRuntimeValue->get_text().empty () == false))
	{
	  // Check bounds
	  if ( (newValue >= 0) && (newValue <= 999999) )
		nutConfig->setShutdownBatteryRuntime(newValue);
	  else
		{
		  // FIXME: deal with value < battery.charge.low 
		  pspUtils->displayInfoDialog(_("Remaining backup time value\nmust be between 0 and 999999"));
		  // don't check the rest and return
		  finalizeSaveCfg();
		  return;
		}
	}
  else
		nutConfig->setShutdownBatteryRuntime(-1);

  // Check the shutdown configuration 
  //rbCustomShutdown + customSdCommand
  if (nutConfig->getShutdownType() == NutConfig::SD_CUSTOM)
	nutConfig->setCustomShutdownCommand(customSdCommand->get_text());

  // Check "Icon display in the taskbar"
  nutConfig->setDisplaySystray(ckbtIconDisplay->get_active());
  mainWinPtr->nutDlg->manageSysTray();
  //  mainWinPtr->nutDlg->sysTray->setVisibility(ckbtIconDisplay->get_active());

  // Note: if we've reached that function, there's
  // always changes to commit!
  // Only need to dump wizard.conf for these values
  nutConfig->dumpPspConfiguration();
  nutConfig->dumpUpsschedConfiguration();
  nutConfig->dumpUpsmonConfiguration();
  nutConfig->dumpAutostartConfiguration();
  
  // Check for restarting or simply reloading services
  SystemService *nutService = new class SystemService();
  if (needServiceRestart == true)
	{
	  if (nutService->restartService() == false)
		std::cerr << "Failed to restart services" << std::endl;
	  
	  needServiceRestart = false;
	}
  else
	{
	  if (nutService->reloadService() == false)
		std::cerr << "Failed to	 reload services" << std::endl;
	}
  
  delete nutService;

  finalizeSaveCfg();
}


void ConfigView::on_ckbtIconDisplay_toggled()
{
  // Activate the save button
  btSaveCfg->set_sensitive(true);
}

void ConfigView::on_btAdminMode_released()
{
  bool mainWinState = mainWinPtr->getVisibility ();
  bool systrayState;
  bool evtWinState = mainWinPtr->nutDlg->evtWin->getVisibility ();
  int tries = 3;
  bool retCode = false;
  Glib::ustring *rootCmd = new Glib::ustring(*pspCmd + Glib::ustring(" --view settings"));

  if (mainWinPtr->nutDlg->sysTray == NULL)
		systrayState = false;
  else
		systrayState = mainWinPtr->nutDlg->sysTray->getVisibility ();

  // Hide mainWin, evtWin and systray
  if (mainWinState == true)
		mainWinPtr->setVisibility (false);
 
  if (systrayState == true) // delete systray to avoid non refreshed view
	{
	  nutConfig->setDisplaySystray(false);
	  mainWinPtr->nutDlg->manageSysTray();
// 	  mainWinPtr->nutDlg->sysTray->setVisibility (false);
// 	  delete mainWinPtr->nutDlg->sysTray;
// 	  mainWinPtr->nutDlg->sysTray = NULL;
	}

  mainWinPtr->nutDlg->evtWin->setVisibility (false);

  // refresh all
  while( Gtk::Main::events_pending() )
		Gtk::Main::iteration();

  // Call MgeUtils::switchToRoot("?argv[0]? --settings")
  while ( (retCode == false) && (tries > 0) )
	{
	  tries --;
	  std::cout << "Command: " << rootCmd->c_str() << std::endl;
	  retCode = pspUtils->switchToRoot(rootCmd); // FIXME: --settings
	  // FIXME: Glib::Thread *tid = Glib::Thread::create(sigc::mem_fun(pspUtils, &MgeUtils::switchToRoot), false);
	}

  std::cout << "POST SWITCH TO ROOT.... " << std::endl;

  // Check if we failed
  if ( (retCode == false) && (tries == 0) )
		return;

  // FIXME: check if mainwin/systray/evtWin were previously shown...
  mainWinPtr->setVisibility (mainWinState);
  mainWinPtr->nutDlg->evtWin->setVisibility (evtWinState);
  if ( systrayState != false)
 	{
	  nutConfig->setDisplaySystray(systrayState);
	  mainWinPtr->nutDlg->manageSysTray();
	//	mainWinPtr->nutDlg->sysTray->setVisibility (systrayState);
 	}

//   mainWinPtr->nutDlg->manageSysTray();
//   mainWinPtr->configDlg->nutConfig->setDisplaySystray(true);
//   mainWinPtr->setVisibility (true); //show();

  // refresh all
  //  while( Gtk::Main::events_pending() )
  // 	Gtk::Main::iteration();

  // Restore configuration values as these might have changed
  restoreConfig();
}

void ConfigView::setUserMode(int mode)
{
  std::cout << "setUserMode(" << mode << ")" << std::endl;

  pspUtils->setAdminMode(mode);

  switch (pspUtils->getAdminMode())
	{
	case MgeUtils::ADMIN_MODE:
	  std::cout << "case MgeUtils::ADMIN_MODE" << std::endl;
	  // Activate everything
	  frmSdCriteria->set_sensitive(true);
  	  //sdTimerValue->set_sensitive(true);
 	  ckbtSdTimer->set_sensitive(true);
	  //sdBattLevelValue->set_sensitive(true);
	  ckbtBattLevel->set_sensitive(true);
	  //sdRuntimeValue->set_sensitive(true);
	  ckbtSdRuntime->set_sensitive(true);

	  frmIconDisplay->set_sensitive(true);
	  ckbtIconDisplay->set_sensitive(true);

	  frmSdConfig->set_sensitive(true);
	  frmSdType->set_sensitive(true);
	  rbNoShutdown->set_sensitive(true);
	  rbShutdown->set_sensitive(true);
	  rbCustomShutdown->set_sensitive(true);

	  // Enable the "Admin Mode" button
	  btAdminMode->set_sensitive(false);
	  break;
	case MgeUtils::USER_MODE:
	default:
	  std::cout << "case MgeUtils::USER_MODE || default" << std::endl;
	  // Deactivate everything
	  // fxStatus->set_sensitive(false); => not working (invalidate everything, including bts)

	  frmSdCriteria->set_sensitive(false);
  	  sdTimerValue->set_sensitive(false);
 	  ckbtSdTimer->set_sensitive(false);
	  sdBattLevelValue->set_sensitive(false);
	  ckbtBattLevel->set_sensitive(false);
	  sdRuntimeValue->set_sensitive(false);
	  ckbtSdRuntime->set_sensitive(false);

	  frmIconDisplay->set_sensitive(false);
	  ckbtIconDisplay->set_sensitive(false);

	  frmSdConfig->set_sensitive(false);
	  frmSdType->set_sensitive(false);
	  rbNoShutdown->set_sensitive(false);
	  rbShutdown->set_sensitive(false);
	  rbCustomShutdown->set_sensitive(false);

	  // Disable the "Admin Mode" button
	  btAdminMode->set_sensitive(true);
	  break;
	}
}

void ConfigView::setFont(const Glib::ustring fontName)
{
  lblSdCriteria->modify_font(Pango::FontDescription(fontName));
  // FIXME: This doesn't work!?
  // ckbtSdTimer->modify_font(Pango::FontDescription(fontName));
  // ckbtSdTimer->get_style()->set_font(Pango::FontDescription(fontName));
  lblSdTimer->modify_font(Pango::FontDescription(fontName));

  sdTimerValue->modify_font(Pango::FontDescription(fontName));
  label128->modify_font(Pango::FontDescription(fontName));

  // FIXME: This doesn't work!?
  // ckbtBattLevel->modify_font(Pango::FontDescription(fontName));
  lblBattLevel->modify_font(Pango::FontDescription(fontName));
  sdBattLevelValue->modify_font(Pango::FontDescription(fontName));
  label129->modify_font(Pango::FontDescription(fontName));

  // FIXME: This doesn't work!?
  // ckbtSdRuntime->modify_font(Pango::FontDescription(fontName));
  lblSdRuntime->modify_font(Pango::FontDescription(fontName));
  sdRuntimeValue->modify_font(Pango::FontDescription(fontName));
  label130->modify_font(Pango::FontDescription(fontName));
  lblSdConfiguration->modify_font(Pango::FontDescription(fontName));
  lblSdType->modify_font(Pango::FontDescription(fontName));
  // FIXME: This doesn't work!?
  // rbNoShutdown->modify_font(Pango::FontDescription(fontName));
  lblNoShutdown->modify_font(Pango::FontDescription(fontName));
  rbShutdown->modify_font(Pango::FontDescription(fontName));
  lblShutdown->modify_font(Pango::FontDescription(fontName));
  rbCustomShutdown->modify_font(Pango::FontDescription(fontName));
  lblCustomShutdown->modify_font(Pango::FontDescription(fontName));
  lblCustomCmd->modify_font(Pango::FontDescription(fontName));
  customSdCommand->modify_font(Pango::FontDescription(fontName));
  lblSdDurationFrm->modify_font(Pango::FontDescription(fontName));
  lblSdDuration->modify_font(Pango::FontDescription(fontName));
  SdDurationValue->modify_font(Pango::FontDescription(fontName));
  //lblFrmUpsShutoff->modify_font(Pango::FontDescription(fontName));
  // FIXME: This doesn't work!?
  // ckbtShutoff->modify_font(Pango::FontDescription(fontName));
  //lblUpsShutoff->modify_font(Pango::FontDescription(fontName));
  lblFrmIconDisplay->modify_font(Pango::FontDescription(fontName));
  // FIXME: This doesn't work!?
  // ckbtIconDisplay->modify_font(Pango::FontDescription(fontName));
  lblIconDisplay->modify_font(Pango::FontDescription(fontName));
  btAdminMode->modify_font(Pango::FontDescription(fontName));
  btSaveCfg->modify_font(Pango::FontDescription(fontName));

}
