// A Glademm configuration GUI using NutConfig. 
/**
 * This class presents a configuration GUI using NutConfig.
 *
 * @author Arnaud Quette <arnaud.quette@mgeups.com>
 * @version 2004/12/22 Creation
 *
 * Copyright (C) 2004 - 2005 by MGE UPS SYSTEMS
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2.
 *  Please, read the COPYING file provided with this software for the full text
 */

#ifndef _CONFIGVIEW_HH 
#  include <gtkmm.h>
#  include "ConfigView_glade.hh"
#  define _CONFIGVIEW_HH

#include "view.h"
#include "NutConfig.h"

class ConfigView
  : public ConfigView_glade ,
	public View
{   
public:

  // Constructeur
  ConfigView(NutConfig *nutCfgClass, int baseUserMode=MgeUtils::USER_MODE);

  bool refreshView();

  Gtk::Widget *getViewContent() { return vpContent->get_child (); };
  Gtk::Widget *getViewPort() { return vpContent; };

  void on_sdTimerValue_changed();
  void on_sdTimerValue_editing_done();
  void on_sdBattLevelValue_changed();
  void on_sdRuntimeValue_changed();
  void on_ckbtSdTimer_toggled();
  void on_ckbtBattLevel_toggled();
  void on_ckbtSdRuntime_toggled();

  void on_btSaveCfg_released();
  void on_ckbtIconDisplay_toggled();
  void on_rbShutdown_toggled();
  void on_rbCustomShutdown_toggled();
  void on_customSdCommand_changed();

  void on_btAdminMode_released();

  bool restoreConfig();

  //private:
  NutConfig *nutConfig;

  void setUserMode(int mode);

  void setFont(const Glib::ustring fontName);

private:
  bool needServiceRestart;
  void finalizeSaveCfg();

protected:
  //Tree model columns:
  class ModelColumns : public Gtk::TreeModel::ColumnRecord
  {
  public:
	
	ModelColumns() { add(colName); }
	
	Gtk::TreeModelColumn<Glib::ustring> colName;
  };
  
  ModelColumns curColumns;

private:
  bool changesToCommit;
};
#endif
