// generated 2005/3/10 10:51:14 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to EventWin.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "gettext.h"

#  include <gdkmm.h>

#include "EventWin.hh"
// FIXME: a supprimer??
#include "MainWindow.hh"
#include "MgeUtils.h"


EventWin::EventWin(Glib::ustring initialStatus)
{
  // Window's icon
  if(set_icon_from_file (mainWinPtr->find_pixmap_file ("mgeops-psp-32.png")) != true)
	std::cout << "setIcon failed" << std::endl;

  //Create the list model
  refListModel = Gtk::ListStore::create(eventColumns);
  tvEvents->set_model(refListModel);

  Gtk::TreeView::Column* pColumn = Gtk::manage( new Gtk::TreeView::Column("Date") );
  pColumn->pack_start(eventColumns.eventIcon, false); //false = don't expand.
  pColumn->pack_start(eventColumns.eventDate);

  tvEvents->append_column(*pColumn);

  //tvEvents->append_column("Date", eventColumns.eventDate);
  //tvEvents->get_column(1)->set_max_width(0);

  tvEvents->append_column("Message", eventColumns.eventText);

  // Final beautification
  // Keep on foreground
  //set_keep_above (true);

  // Hide for the moment
  setVisibility(false);

  // FIXME: really set to foreground (ie above menu panel)
  // Set the root window
  //get_window()->reparent (get_root_window (), 0, 0);

  // FIXME: remove decoration (apart from close)
  // get_window ()->set_decorations( Gdk::DECOR_ALL | Gdk::DECOR_BORDER | Gdk::DECOR_TITLE); 
  //  get_window()->set_decorations( Gdk::DECOR_ALL | Gdk::DECOR_MENU);
//  								| Gdk::DECOR_MINIMIZE
//  								| Gdk::DECOR_MAXIMIZE ); 
  //setVisibility(false);

  // FIXME: font change seems not to work after widget realise!
  modify_font(Pango::FontDescription(TEXT_FONT1));
  tvEvents->modify_font(Pango::FontDescription(TEXT_FONT1));

  // Keep on foreground
  //set_keep_above (true);

  // move (int x, int y)
  // Asks the window manager to move window to the given position. 
//   signal_hide().connect(sigc::mem_fun(*this, &EventWin::on_EventWin_hide));
//   signal_focus_out_event().connect(sigc::mem_fun(*this, &EventWin::on_EventWin_focus_out_event));
//   signal_unmap_event().connect(sigc::mem_fun(*this, &EventWin::on_EventWin_unmap_event));

  prevStatus = initialStatus;
}

void EventWin::addEvent(Glib::ustring eventName, int evtSeverity)
{
  time_t		currentTime = time(NULL);
  Glib::ustring	newEvent;
  char			i18nTime[32];
  char			*tmp;

  // FIXME: ?buggy? Glib::Date *timeStamp = new class Glib::Date ();
  // seems not to manage H:M:S (limitation to be bugged upstream!)
  //   Glib::Date *i18nTimeNew = new class Glib::Date ();
  //   i18nTimeNew->set_time(time(NULL));
  //   std::cout << "TEST TIME = " << i18nTimeNew->format_string ("%c").c_str() << std::endl;
  
  // Create the timestamp
  strftime (&i18nTime[0], 32, "%c", localtime(&currentTime));
  if ((tmp=strstr(i18nTime, "CEST")) != NULL)
	*(tmp--) = '\0';

  std::cout << "Event: " << Glib::locale_to_utf8(i18nTime) << std::endl;

  // FIXME: make a table for event transition
  // No status change
  if (prevStatus.compare(eventName) == 0)
	return;
  else
	{
	  // Handle return from bypass
	  if ( (prevStatus.compare(_("Output on bypass")) == 0)
		   && (eventName.compare(_("Utility restored")) == 0) )
		{
		  prevStatus = Glib::ustring(_("Bypass : Return on UPS"));
		  newEvent = prevStatus;
		}
	  else
		{
		  // Handle communication restored
		  if ( (prevStatus.compare(_("Communication failure")) == 0)
			   && (eventName.compare(_("Utility restored")) == 0) )
			{
			  prevStatus = Glib::ustring(eventName);
			  newEvent = Glib::ustring(_("Communication restored"));;
			}
		  else
			{
			  prevStatus = Glib::ustring(eventName);
			  newEvent = eventName;
			}
		}
	}

  // Create the new row
  Gtk::TreeModel::Row row = *(refListModel->append());
  row[eventColumns.eventText] = newEvent.c_str();
  row[eventColumns.eventDate] = Glib::ustring(Glib::locale_to_utf8(i18nTime));
  row[eventColumns.eventIcon] = Gtk::Image(getSeverityIcon(evtSeverity)).get_pixbuf();

  // Set focus on the last event
  Glib::RefPtr<Gtk::TreeSelection> m_tree_sel_ref = tvEvents->get_selection ();
  Gtk::TreeModel::Path path = refListModel->get_path (row);
  m_tree_sel_ref->select (path);
  tvEvents->scroll_to_row (path);

  setVisibility(true);
}


void EventWin::setFont(const Glib::ustring fontName)
{
  tvEvents->modify_font(Pango::FontDescription(fontName));
}

void EventWin::on_EventWin_hide ()
{
//   std::cout << "\nHide event\n" << std::endl;
//   //exit(0);
//   present ();
}

bool EventWin::on_EventWin_focus_out_event (GdkEventFocus* event)
{
//   hide();
   std::cout << "\nfocus_out event\n" << std::endl;
//   //exit(0);
//   raise();
   present ();
   stick ();
}

bool EventWin::on_EventWin_unmap_event(GdkEventAny* event)
{
//   hide();
   std::cout << "\nunmap_event event\n" << std::endl;
//   //exit(0);
//   raise();
   present ();
   stick ();
}

std::string EventWin::getSeverityIcon(int eventSeverity)
{
  std::string severityIconName;

  switch (eventSeverity)
	{
	case SEVERITY_HIGH:		// bulred
	  //severityIconName = mgeUtilsPtr->findPixmapFile ("alarm-red.png");
	  severityIconName = mainWinPtr->find_pixmap_file ("alarm-red.png");
	  break;
	case SEVERITY_MEDIUM:	// bulyellow
	  //severityIconName = mgeUtilsPtr->findPixmapFile ("alarm-yellow.png");
	  severityIconName = mainWinPtr->find_pixmap_file ("alarm-yellow.png");
	  break;
	default:
	case SEVERITY_NORMAL:	// bulgreen
	  //severityIconName = mgeUtilsPtr->findPixmapFile ("alarm-green.png");
	  severityIconName = mainWinPtr->find_pixmap_file ("alarm-green.png");
	  break;
	}
  return severityIconName;
}
