// generated 2004/12/15 16:45:06 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to MainWindow.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "MainWindow.hh"
#include "splashwin.hh"
#include <iostream>

#include "gettext.h"

MainWindow *mainWinPtr;
extern splashwin *splashWinPtr;
extern Gtk::Main m;

// FIXME: arg(view) or call setView afterward!?
MainWindow::MainWindow(NutConfig *nutCfgClass, const char *viewName, gboolean visible)
{
  std::cout << "MainWindow(view=" << viewName << ")" << std::endl;

	configDlg = NULL;
	nutDlg = NULL;
	aboutDlg = NULL;
	historyDlg = NULL;

  // FIXME: manage with MgeUtils
  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  // Final beautification
  // Program' icon
  if(set_icon_from_file (find_pixmap_file ("mgeops-psp-32.png")) != true)
		std::cout << "setIcon failed" << std::endl;

	// Specific Manufacturer ressources
	set_title(MFR_NAME " - Personal Solution-Pac");
//	image14->set(find_pixmap_file (MFR_LOGO)); // set logo
	image32->set(find_pixmap_file (MFR_WAVE)); // set wave
	
  // Variables init
  mainWinPtr = this;
  setVisibility (visible);

  // Prepare the views  
  // Config view
  if ((Glib::get_user_name ()).compare("root") != 0)
		configDlg = new class ConfigView(nutCfgClass);
  else
	{
	  // set isRoot...
	  configDlg = new class ConfigView(nutCfgClass, MgeUtils::ADMIN_MODE);
	}
  viewContentConfig = configDlg->getViewContent();

  // Status view
  nutDlg = new class StatusView();
  viewContentStatus = nutDlg->getViewContent(); 

  // Adapt the btExit label (Exit or Close) according
  // to the systray availability/visibility
  if ( (nutDlg->sysTray) && (nutDlg->sysTray->getVisibility () == true) )
		btExit->set_label(_("Close"));
  else
		btExit->set_label(_("Exit"));
  
  // About view
  if (nutDlg->nutClient->nutVersion->empty () == true)
		aboutDlg = new class AboutView();
  else
		aboutDlg = new class AboutView(*nutDlg->nutClient->nutVersion, 
								   *nutDlg->nutClient->driverName, 
								   *nutDlg->nutClient->driverVersion);

  viewContentAbout = aboutDlg->getViewContent();
  
  // History view
  // Fixme:
  historyDlg = new class HistoryView();
  viewContentHistory = historyDlg->getViewContent();
  //   viewContentHistory = Gtk::manage(new class Gtk::Fixed());

  // Help view
  // Fixme:
  helpDlg = new class HelpView();
  viewContentHelp = helpDlg->getViewContent();
  //   viewContentHelp = Gtk::manage(new class Gtk::Fixed());

  // Call setView a 1rst time with status, to avoid
  // blank page when psp is called with "-v help"!
  setView("status");
  
  // And set the default view as desired
  setView(viewName);

  switch(pspUtils->getSystemType())
	{
	  case MgeUtils::SYSTEM_TYPE_SUSE:
      pspFont.set_size(12 * PANGO_SCALE);
      break;
    default:
      pspFont.set_size(10 * PANGO_SCALE);
      break;
  }
      
  // Standard font for all label
  setFont(pspFont.to_string()); // TEXT_FONT1);
}

void MainWindow::setView(const char *viewName)
{
  Gtk::Widget *viewContent;

  std::cout << "setting view: " << viewName << std::endl;

  // nothing to do
  if ((currentViewName.compare(viewName) == 0)
	  || (Glib::ustring(viewName).compare("help") == 0))
	return;

  // get and detach the current view content
  if (vpContent->get_child () )
	{
	  vpContent->remove();
	}
  
  if (Glib::ustring(viewName).compare("about") == 0)
	{
	  // Check if Nut information have been filled
	  if (aboutDlg->isNutInfoFilled() == false)
		{
		  aboutDlg->setNutInfo(*nutDlg->nutClient->nutVersion, 
							   *nutDlg->nutClient->driverName, 
							   *nutDlg->nutClient->driverVersion);
		}
	  currentView = aboutDlg;
	  //aboutDlg->refreshView();
	  currentView->refreshView();
 	  viewContent = viewContentAbout;
	}

  if (Glib::ustring(viewName).compare("status") == 0)
	{
	  currentView = nutDlg;
 	  viewContent =  viewContentStatus;
	}

  if ((Glib::ustring(viewName).compare("config") == 0)
	  || (Glib::ustring(viewName).compare("settings") == 0))
	{
	  currentView = configDlg;
	  //configDlg->refreshView();
	  currentView->refreshView();
  	  viewContent = viewContentConfig;
	}

  if (Glib::ustring(viewName).compare("history") == 0)
	{
 	  currentView = historyDlg;
  	  viewContent = viewContentHistory;
	}

  if (Glib::ustring(viewName).compare("help") == 0)
	{
 	  currentView = helpDlg;
  	  viewContent = viewContentHelp;
	}
 
  // Set the current view accessor
  //  viewContent = currentView->getViewContent();

  // Reparent the old view to its native window
//   if (currentView->getViewContent()->get_parent () != 0)
// 	{
// 	  std::cout << "===========================> reparent old view" << std::endl;
// 	  currentView->getViewContent()->reparent (*currentView->getViewPort() );
// 	}

  // Reparent the new view from its native window
  // FIXME: mega glitch here cause a segfault
  if ((viewContent->get_parent () != mainWinPtr->vpContent)
	  && (viewContent->get_parent() != 0))
	{
	  std::cout << "===========================> parents are different" << std::endl;
 	  viewContent->reparent (*mainWinPtr->vpContent);
/* FIXME: remove the warning due to reparenting
 	  gtk_widget_ref(viewContent);
    gtk_container_remove(GTK_CONTAINER(viewContent->get_parent ()), viewContent);
    gtk_container_add(GTK_CONTAINER(mainWinPtr->vpContent), viewContent);
    gtk_widget_unref(viewContent);
*/	  
	}

  //  else
  vpContent->add(*viewContent);
  if (getVisibility () != false)
	{
	  viewContent->show();
	  vpContent->show_all_children();
	  vpContent->show();
	}

  // Store the current view' info
  currentViewName = viewName;
}

void MainWindow::gtk_main_quit()
{
  std::cout << "MainWindow::gtk_main_quit()" << std::endl;

  // If the SystemTray is hidden/inactive, or if we're back
  // from switchToRoot we can exit...
  if ( (!nutDlg->sysTray) || (nutDlg->sysTray->getVisibility() == false) )
	{
	  std::cout << "Quiting application, cleaning context..." << std::endl;

	  // save current state
	  // FIXME

	  // Close EventWin if opened
	  delete mainWinPtr->nutDlg->evtWin;

	  // Close NUT connexion
	  mainWinPtr->nutDlg->nutClient->disconnect();

	  // Remove the instance lock
	  pspUtils->destroyAppLock();

	  // and quit
	  m.quit();
	}
  else
	{
	  // ... Otherwise, simply hide ourself
	  setVisibility (false);
	}
}

void MainWindow::setFont(Glib::ustring fontName)
{
  std::cout << "Font name: " << fontName << std::endl;

  // Set own widget's fonts
  lblBtStatus->modify_font(Pango::FontDescription(fontName));
  lblBtHistory->modify_font(Pango::FontDescription(fontName));
  lblBtSettings->modify_font(Pango::FontDescription(fontName));
  lblBtHelp->modify_font(Pango::FontDescription(fontName));
  lblBtAbout->modify_font(Pango::FontDescription(fontName));
  btExit->modify_font(Pango::FontDescription(fontName));

  // cascaded call to setFont
  // AboutView
  aboutDlg->setFont(fontName);
  // ConfigView
  configDlg->setFont(fontName);
  // StatusView
  nutDlg->setFont(fontName);
  // HelpView
  helpDlg->setFont(fontName);
  // HistoryView 
  historyDlg->setFont(fontName);
}
