// generated 2004/12/15 16:45:06 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to MainWindow.hh_new

// you might replace
//    class foo : public foo_glade { ... };
// by
//    typedef foo_glade foo;
// if you didn't make any modifications to the widget

#ifndef _MAINWINDOW_HH
#  include "MainWindow_glade.hh"
#  define _MAINWINDOW_HH

#include "StatusView.hh"
#include "AboutView.hh"
#include "ConfigView.hh"
#include "HelpView.hh"
#include "HistoryView.hh"
#include "MgeUtils.h"

#include <iostream>

//#define TEXT_FONT1 "Fixed[Misc] 9"
#define TEXT_FONT1 "Utopia 10"

class MainWindow;
extern MainWindow *mainWinPtr;
extern MgeUtils *pspUtils;

class MainWindow : public MainWindow_glade
{  
public:   
  MainWindow(NutConfig *nutCfgClass, const char *viewName="status", gboolean visible=true);

		// Views accessors
		void setView(const char *viewName);
		Glib::ustring getCurrentViewName() { return currentViewName; }

		// Visibility accessors
		bool getVisibility () { return bVisibility; }
		void setVisibility (gboolean visible)
		{
		  bVisibility = visible;

		  if (visible == true)
			{
			  show_all_children();
			  show ();
			}
		  else
			hide ();
		}
		void toggleVisibility()
		{
		  setVisibility ((bVisibility == true)?false:true);
		}

        bool on_delete_event (GdkEventAny* event  )
		{
		  toggleVisibility();
		}

		// Support functions
		void refreshView() 
		{ 
		  // 		  if (currentViewName == "status")
		  // Always refresh the status view (at least for the systray) 
		  nutDlg->refreshView();
		  Gtk::Main::iteration(true);
		  // FIXME: refresh the current view
		}

		// Support class
		//MgeUtils *pspUtils;

		// Buttons action callbacks
		void on_btStatus_released() { setView("status"); }
		void on_btCommands_released() { setView("commands"); }
		void on_btHistory_released() { 
			/* setView("history"); */
			nutDlg->evtWin->show();
		}
		void on_btConfig_released() { setView("config"); }
		void on_btHelp_released() { pspUtils->launchHelpViewer(); }
		void on_btAbout_released(){ setView("about"); }

		// Buttons motion callbacks
		// FIXME: create a setMotion for button motion over
        void on_btStatus_enter()
		{
		  std::cout << "enter event" << std::endl;
		}
        void on_btHistory_enter()
		{
		  std::cout << "enter event" << std::endl;
		}
        void on_btConfig_enter()
		{
		  std::cout << "enter event" << std::endl;
		}
        void on_btAbout_enter()
		{
		  std::cout << "enter event" << std::endl;
		}
        void on_btHelp_enter()
		{
		  std::cout << "enter event" << std::endl;
		}

		// Clean exit callback
        void gtk_main_quit();

		// Native raw windows (to extract views)
		AboutView *aboutDlg;
		ConfigView *configDlg;
		StatusView *nutDlg;
		HelpView *helpDlg;
		HistoryView *historyDlg;

		// Fonctions de support
		// Accesseurs de graphismes
		std::string find_pixmap_file (const std::string filename)
		{
 		  list<string>::const_iterator xpmDirIterator;

		  // We step through each of the pixmaps directory to find it.
 		  xpmDirIterator = pixmapsDirectories.begin();

 		  while (xpmDirIterator != pixmapsDirectories.end())
 			{
			  //std::string* pathname = Glib::build_filename((std::string *) xpmDirIterator, filename);
			  std::string pathname = Glib::build_filename(*xpmDirIterator, filename);
		  	  try
			  {
				  if (Glib::file_test (pathname, Glib::FILE_TEST_EXISTS))
					{
					  cout << "Pixmap (" << filename << ") found in: " << *xpmDirIterator << endl;
					  return pathname;
					  // break;
					}
				  else
					{
					  xpmDirIterator++;
					}
			  }
			  catch (Glib::FileError& e)
				{
				}
 			}
		  cout << "Pixmap not found!!" << endl;
		  return "";
		}

  void setFont(Glib::ustring fontName);
  Pango::FontDescription pspFont;

protected:
		void add_pixmap_directory (const std::string &directory) {
		  pixmapsDirectories.push_back(directory);
		}

private:
		// Stores the current view name and pointer (defaults to status)
		Glib::ustring currentViewName;	
		View *currentView;

		// Extracted views
		Gtk::Widget *viewContentStatus;
		Gtk::Widget *viewContentHistory;
		Gtk::Widget *viewContentConfig;
		Gtk::Widget *viewContentHelp;
		Gtk::Widget *viewContentAbout;

		// is the main GUI currently visible
		bool bVisibility;

		//  Glib::ListHandle<Glib::ustring>& pixmapsDirectories;
  list<string> pixmapsDirectories;
  //gl.push_back("String 1");
};
#endif
