// A more graphical Progress Bar widget for GTK2. 
/**
 * This class allows to manipulate a more graphical Progress Bar
 * widget for GTK2.
 *
 * @author Arnaud Quette <arnaud.quette@mgeups.com>
 * @version 2004/12/22 Creation
 *
 * Copyright (C) 2004 by MGE UPS SYSTEMS
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2.
 *  Please, read the COPYING file provided with this software for the full text
 */

#ifndef _MGEPROGRESSBAR_HH
#  include <glibmm.h>
#  include <gtkmm.h>
#  define _MGEPROGRESSBAR_HH

#include <config.h>

class MgeProgressBar
{
 public:
  /// Default constructor
   MgeProgressBar();
   MgeProgressBar(Gtk::Image *imgBattCharge);

  /// Accessors
  void setFraction(int battPercentage);
  void hide();

 private:
  /// Image container displayed
  Gtk::Image *imgBase;
  Glib::RefPtr<Gdk::Pixbuf> imgPgbBg;
  Glib::RefPtr<Gdk::Pixbuf> imgPgbFg;
};

#endif
