// A multi environment system tray for GTK2. 
/**
 * This class allows to have a system tray, that display status
 * information and permit to access to PSP function through menu
 * entries, working with both KDE, Gnome and other environments.
 *
 * @author Arnaud Quette <arnaud.quette@mgeups.com>
 * @version 2004/01/04 Creation
 *
 * Copyright (C) 2004 by MGE UPS SYSTEMS
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2.
 *  Please, read the COPYING file provided with this software for the full text
 */

#ifndef _MGESYSTEMTRAY_HH
#  include <glibmm.h>
#  include <gtkmm.h>
#  include <gdkmm.h>
#  define _MGESYSTEMTRAY_HH

#include <config.h>
#include "MgeUtils.h"
#include "eggmm/tray-icon.h"
//#include "eggmm/status-icon.h"

class MgeSystemTray : public Egg::TrayIcon
{
 public:
  MgeSystemTray(const Glib::RefPtr<Gdk::Pixbuf>& pixbuf);
  MgeSystemTray(const Glib::RefPtr<Gtk::Image>& image);
  ~MgeSystemTray();

  // accessors
  void setPixbuf(const Glib::RefPtr<Gdk::Pixbuf>& pixbuf);
  void setImage(const Glib::RefPtr<Gtk::Image>& image);
  void setImage(const std::string imageName);
  void setTooltip(const Glib::ustring& tip, const Glib::ustring& private_tip = Glib::ustring());

  // Callbacks
  void onUpsStatusActivate();

  // Should the systray be visible?
  void setVisibility(bool visibility);
  bool getVisibility () { //(bVisible==true)?true:false;
	if (bVisible==true)
	  {
		std::cout << "MgeSystemTray is visible" << std::endl;
		return true;
	  }
	else
	  {
		std::cout << "MgeSystemTray is not visible" << std::endl;
		return false;
	  }
  }

 private:
  bool bVisible;

  // Menu Callbacks
  bool onTrayClicked(GdkEventButton* event);
  bool onTrayMenu(GdkEventButton* event);
  void onUpsMenuActivate();
  void onSettingsMenuActivate();
  void onAboutMenuActivate();
  void onExitMenuActivate();
  void onHelpMenuActivate();

  MgeUtils pspUtils;

  Gtk::EventBox* evtBox;
  Gtk::Image*    imgStatus;
  Gtk::Tooltips  toolTips;
};

#endif
