
#include <iostream>
#include <config.h>
#include "MgeUtils.h"
#include <string>

#include <pwd.h>
#include <sys/types.h>

#include <signal.h>
#include <errno.h>

#include "gettext.h"

// FIXME: not clean
#include "MainWindow.hh"
extern MainWindow *mainWinPtr;
extern Gtk::Main m;
extern int errno;

#include "dlgInfo.hh"

MgeUtils *mgeUtilsPtr;


MgeUtils::MgeUtils()
{
  lockFileName = new Glib::ustring(Glib::get_home_dir () + "/.mgeops-psp.lock");
  std::cout << "lockfile is " << lockFileName->c_str () << std::endl;

  // Variables init
  mgeUtilsPtr = this;

  // Utils init
  addPixmapDirectory (PACKAGE_PIXMAPS_DIR);
  addPixmapDirectory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
}

std::string MgeUtils::findPixmapFile (const std::string filename)
{
  std::list<std::string>::const_iterator xpmDirIterator;

  std::cout << "findPixmapFile(" << filename << ")" << std::endl;

  // We step through each of the pixmaps directory to find it.
  xpmDirIterator = pixmapsDirectories.begin();

  while (xpmDirIterator != pixmapsDirectories.end())
	{
	  std::cout << "looking in:" << *xpmDirIterator << std::endl;
	  
	  //std::string* pathname = Glib::build_filename((std::string *) xpmDirIterator, filename);
	  std::string pathname = Glib::build_filename(*xpmDirIterator, filename);
	  try
	  {
		  if (Glib::file_test (pathname, Glib::FILE_TEST_EXISTS))
			{
			  std::cout << "Pixmap (" << filename << ") found in: " << *xpmDirIterator << std::endl;
			  return pathname;
			  // break;
			}
		  else
			{
			  xpmDirIterator++;
			}
		}
	  catch (Glib::FileError& e)
		{
		}
	}
  cout << "Pixmap not found!!" << endl;
  return "";
}

void MgeUtils::addPixmapDirectory (const std::string &newDirectory)
{
  pixmapsDirectories.push_back(newDirectory);
}

// Try to access /etc/issue to get the system name [and release]
// Fixme: use /etc/lsb-release when available...
int MgeUtils::getSystemType()
{
  int bTest;
  int retValue = MgeUtils::SYSTEM_TYPE_UNKNOWN;
  Glib::ustring lineRead;
  Glib::RefPtr<Glib::IOChannel> etcIssue;

  try
	{
	  etcIssue = Glib::IOChannel::create_from_file ("/etc/issue", "r");
	}
  catch (Glib::FileError& e)
	{
	  return retValue;
	}

	/// We only need the read the first line to get info
	try
	{
		Glib::IOStatus retCode;
		// Read the first non empty line
		while (1)
		{
			retCode = etcIssue->read_line (lineRead);
			if ( (retCode != Glib::IO_STATUS_ERROR)
				&& (lineRead.compare(0, 1, "\n") == 0) )
				continue;
			else
				break;
		}
	
		std::cout << "/etc/issue: " << lineRead.c_str() << std::endl;

		if (retCode != Glib::IO_STATUS_ERROR)
		{
			// Fixme: use ustring::find whenever possible, and case insensitive comparison

			// search for Debian...
			// FIXME: derivatives expose Debian or (Ubuntu, lindows, ...)
			if ( ((bTest = lineRead.compare(0, 6, _("Debian"))) == 0)
				||  ((bTest = lineRead.compare(0, 6, _("Ubuntu"))) == 0) )
			{
				std::cout << "System is: Debian GNU/Linux" << std::endl;
				retValue = MgeUtils::SYSTEM_TYPE_DEBIAN;
			}
			/// search for Mandriva (for consolehelper)...
/*			else if ((bTest = lineRead.compare(0, 27, _("Mandriva Linux release 2007"))) == 0)
			{
				std::cout << "System is: Mandriva Linux release 2007" << std::endl;
				retValue = MgeUtils::SYSTEM_TYPE_MDK_2007;
			}*/
			/// search for Mandrake / Mandriva...
			else if ( ((bTest = lineRead.compare(0, 13, _("Mandrakelinux"))) == 0)
				|| ((bTest = lineRead.compare(0, 8, _("Mandriva"))) == 0) )
			{
				std::cout << "System is: Mandriva Linux" << std::endl;
				retValue = MgeUtils::SYSTEM_TYPE_MDK;
			}
			/// search for RedHat / Fedora Core...
			else  if ( ((bTest = lineRead.compare(0, 7, _("Red Hat"))) == 0)
				|| ((bTest = lineRead.compare(0, 6, _("Fedora"))) == 0)
				|| ((bTest = lineRead.compare(0, 6, _("CentOS"))) == 0) )
			{
				std::cout << "System is: Red Hat / Fedora" << std::endl;
				retValue = MgeUtils::SYSTEM_TYPE_RHFC;
			}
			/// search for SUSE / Novell
			else if ( ((bTest = lineRead.compare(0, 4, _("SUSE"))) == 0)
				|| ((bTest = lineRead.compare(0, 4, _("Suse"))) == 0)
				|| ((bTest = lineRead.compare(0, 17, _("Welcome to Novell"))) == 0)
				|| ((bTest = lineRead.compare(0, 15, _("Welcome to SuSE"))) == 0)
				|| ((bTest = lineRead.compare(0, 15, _("Welcome to SUSE"))) == 0) 
				|| ((bTest = lineRead.compare(0, 19, _("Welcome to openSUSE"))) == 0) )
			{
				std::cout << "System is: Novell / SuSE" << std::endl;
				retValue = MgeUtils::SYSTEM_TYPE_SUSE;
			}
		}

		/// Close the file
		etcIssue->close();
	}
	catch (Glib::IOChannelError& e)
	{
	}
	
	if (retValue == MgeUtils::SYSTEM_TYPE_UNKNOWN)
		std::cout << "System is: Unknown" << std::endl;
	
	return retValue;
}

// Return true if there is a previous PSP instance,
// false otherwise
bool MgeUtils::checkPrevInstance()
{
  bool retValue = false;

  // Test if the lock file exist
  if (Glib::file_test (*lockFileName, Glib::FILE_TEST_EXISTS) == false)
	{
	  if (createAppLock() == true)
		retValue = false;
	  else
		retValue = true;
	}
  else
	retValue = true;

  // Check its content (PID) to see if the process is really there!	
  if (retValue == true)
	{
	  std::cout << "Old PID is: " << getOldPid() << std::endl;
	  if (kill(getOldPid(), 0) == -1)
		{
		  // Process no more exists
		  if (errno == ESRCH)
			{
			  destroyAppLock();
			  retValue = false;
			}
		}
	}

  return retValue;
}

// return true if ok, false otherwise
bool MgeUtils::createAppLock()
{
  bool retValue = false;
  std::ostringstream pspPid;

  try
	{
	  lockFile = Glib::IOChannel::create_from_file(Glib::ustring(lockFileName->raw()), "w");
	  // Put the PID in it: getpid()
	  pspPid << getpid() << "\n";
	  lockFile->write (pspPid.str());
	  lockFile->close();

	  retValue = true;
	}
  catch (Glib::FileError& e)
	{
	  // FIXME: something went wrong, consider PSP is running?!
	}

  return retValue;
}

// Return the PID in the lockfile
int MgeUtils::getOldPid()
{
	int retValue = -1;
	Glib::ustring lineRead;

  try
	{
	  lockFile = Glib::IOChannel::create_from_file(Glib::ustring(lockFileName->raw()), "r");
	  lockFile->read_line (lineRead);
	  retValue = atoi(lineRead.c_str());
	  lockFile->close();
	}
  catch (Glib::FileError& e)
	{
	  // FIXME: something went wrong, consider PSP is running?!
	}

  return retValue;
}

void MgeUtils::destroyAppLock()
{
  std::cout << "MgeUtils::destroyAppLock(" << lockFileName->raw() << ")" << std::endl;
  deleteFile(lockFileName);
}

bool MgeUtils::signalQuit()
{
 std::cout << "MgeUtils::signalQuit()" << std::endl;
}


void MgeUtils::deleteFile(const Glib::ustring *fileName)
{
  std::string outChannel("/dev/null");
  int exitCode = 0;

  std::cout << "MgeUtils::deleteFile(" << fileName->raw() << ")" << std::endl;

  try
	{
	  Glib::spawn_command_line_sync ("/bin/rm -f " + fileName->raw()); //, //&commandLine,
// 									 &outChannel, // std output
// 									 &outChannel, // std error
// 									 &exitCode);
	} catch (Glib::SpawnError& e)
	{

	}
}


bool MgeUtils::switchToRoot(Glib::ustring *command)
{
  bool retCode = true;
  Glib::ustring currentDesktopEnv, suCommand, fullCommandLine;

  std::cout << "MgeUtils::switchToRoot(" << command->c_str() << std::endl;

  // Allow root to access the local display before exiting
  system("`which xhost` +local:root > /dev/null 2>&1");

	// Store the magic command
	if ( (pspUtils->getSystemType() == MgeUtils::SYSTEM_TYPE_MDK)
		|| (pspUtils->getSystemType() == MgeUtils::SYSTEM_TYPE_RHFC) ) {
		fullCommandLine.append(*command);
	}
	else {
		//suCommand = "`which kdesu || which gnomesu -c || which gksu || /usr/sbin/userhelper -w || which xsu`";
		//suCommand = "SU_CMD=`which kdesu`; if [ $? -ne 0 ] ; then SU_CMD=`which gnomesu`; if [ $? -eq 0 ] ; then SU_CMD=\"$SU_CMD -c\"; else SU_CMD=`which gksu`; if [ $? -ne 0 ] ; then if [ -x /usr/sbin/psp-root ] ; then SU_CMD=/usr/sbin/psp-root; else SU_CMD=`which /usr/sbin/userhelper`; if [ $? -eq 0 ] ; then SU_CMD=\"$SU_CMD -w\"; else SU_CMD=`which xsu`; fi; fi; fi; fi; fi; $SU_CMD ";
		suCommand = "SU_CMD=`which kdesu`; if [ $? -ne 0 ] ; then SU_CMD=`which gnomesu`; if [ $? -eq 0 ] ; then SU_CMD=\"$SU_CMD -c\"; else SU_CMD=`which gksu`; if [ $? -ne 0 ] ; then SU_CMD=`which /usr/sbin/userhelper`; if [ $? -eq 0 ] ; then SU_CMD=\"$SU_CMD -w\"; else SU_CMD=`which xsu`; fi; fi; fi; fi; $SU_CMD ";
	  // Rebuild the command line [with detach mode ('&')]
	  fullCommandLine = suCommand;
	  fullCommandLine.append(" \"");
	  fullCommandLine.append(*command);
	  //fullCommandLine.append("\" &");
	  fullCommandLine.append("\"");
	}

  std::cout << "fullCommandLine = " << fullCommandLine.c_str() << std::endl;

  // Execute the installer and exit
  system(fullCommandLine.c_str());

  retCode = true; // FIXME: check the return code ?

  // recreate appLock now that the new instance has exited
  createAppLock();

  return retCode;
}

void MgeUtils::openURL(const char *url)
{
  std::string cmdLine;
	cmdLine += INSTALL_BIN_PREFIX "/mge-xdg-open ";
	cmdLine += std::string(url);
	
  std::cout << "openURL = " << cmdLine.c_str() << std::endl;

  try {
		Glib::spawn_command_line_async (cmdLine); 
  } catch (Glib::SpawnError& e) 
	{
	  // FIXME: real exception handling code
	}

}

void MgeUtils::launchHelpViewer()
{
	//////////////////////////
	// FIXME: use mge-xdg-open
	//////////////////////////
#if 0
  typedef struct helpViewer {
		std::string helpViewer;
		std::string viewerOption;
  } helpViewer;

  // Favorite PDF viewers
  static helpViewer helpViewers[] =
	{
	  //mozilla / konqueror?
	  // for KDE
	  { "kpdf", ""  },
	  // for Gnome (FIXME: check)
	  { "evince", ""  },
	  { "gpdf", ""  },
	  // Generic 1
	  { "acroread", ""  },
	  // Generic 2
	  { "xpdf", ""  },
	  // Terminating element
	  { "null", "null"  }
	};

  helpViewer *item;
#endif
  Glib::ustring appPath;
  Glib::ustring cmdLine;

	// Determine the doc language
  Glib::ustring lang = Glib::getenv ("LANG");
	std::cout << "System language: " <<  lang.c_str() << std::endl;
  
  if (lang.empty() == false)
	{
	  if (lang.compare(0, 2, "fr") == 0)
			lang = "fr";
	  else 
		{
		  lang = "en";
		}
	}
  else
		lang = "en";
#if 0
  // FIXME: check the running env. for best fitting
  for ( item = helpViewers ; item-> helpViewer != "null" ; item++ )
	{
	  std::cout << "Comparing with " << item->helpViewer << std::endl;

	  if ((appPath = Glib::find_program_in_path (item->helpViewer)) != "")
		break;
	}

  if (appPath == "")
	{
	  dlgInfo *myDlg = new dlgInfo(_("No PDF viewer installed.\nPlease install acroread, kpdf, evince, gpdf or xpdf to be able to read PSP User Manual."));
	}
  else
	{
	  std::cout << "Found as: " << appPath << std::endl;
	  cmdLine += appPath;
#endif
	  
		cmdLine += INSTALL_BIN_PREFIX "/mge-xdg-open ";
	  // FIXME: dyn path and pdf name, and language...
	  cmdLine += PACKAGE_DATA_DIR "/" PACKAGE "/doc/psplinux_user_guide-";
	  cmdLine += lang;
	  cmdLine += ".pdf";

	  std::cout << "Documentation name: " <<  cmdLine << std::endl;

	  // Set "working" mouse cursor
	  mainWinPtr->get_window()->set_cursor (Gdk::Cursor(Gdk::WATCH));

	  //Force the GUI to update:
	  while(Gtk::Main::events_pending())
			Gtk::Main::iteration();
	  
	  sleep (1);
	  
	  try {
			Glib::spawn_command_line_async (cmdLine); 
	  } catch (Glib::SpawnError& e) 
		{
		  // FIXME: real exception handling code
		}

	  // Restore the default mouse cursor
	  mainWinPtr->get_window()->set_cursor (Gdk::Cursor());
//	}
}


void MgeUtils::displayInfoDialog(Glib::ustring text, Glib::ustring icon)
{
  dlgInfo *myDlg = new dlgInfo(text, icon);
}

void MgeUtils::displayInfoDialog_new(Gtk::MessageType type, char* text, bool exitOnDlgClose)
{
  Gtk::Dialog *dialog;
  //   va_list ap;
  //   gchar *msg;

  // Prepare the message
  //   va_start(ap, format);
  //   msg = g_strdup_vprintf(format, ap);
  //   va_end(ap);

  // Prepare the dialog box
  dialog = new Gtk::Dialog ("Warning",	// title
							true		// modal
							);
  // bool use_separator=false)

  // FIXME: add text label and close button

  dialog->set_position(Gtk::WIN_POS_CENTER);
  dialog->set_resizable(false);
  dialog->show_all_children();

// //   lblContent->modify_font(Pango::FontDescription(TEXT_FONT1));
// //   lblContent->set_text(text);
// //   imgContent->set(mgeUtilsPtr->findPixmapFile (icon));
//   //imgContent->set(mainWinPtr->find_pixmap_file (icon));

  // FIXME: connect close to on_closebutton1_released()
  dialog->run();

  if (exitOnDlgClose == true)
	m.quit();
  else // simply destroy Info dialog
	delete dialog;
  //dialog->destroy_(); => protected
}
