// An init.d daemon interface. 
/**
 * This class allows to manipulate init.d script, in order
 * to start, stop, restart, reload services and check their status.
 *
 * @author Arnaud Quette <arnaud.quette@mgeups.com>
 * @version 2004/12/21 Creation
 *
 * Copyright (C) 2004 by MGE UPS SYSTEMS
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2.
 *  Please, read the COPYING file provided with this software for the full text
 */

#ifndef _SYSTEMSERVICE_HH
#  include <glibmm.h>
#  define _SYSTEMSERVICE_HH

#include "MgeUtils.h"

class SystemService //: public Glib::IOChannel
{
 public:
  // 
  SystemService();

  /// Service accessors (wrap upsd, upsmon and driver)
  bool startService();
  bool stopService();
  bool restartService();
  bool reloadService();
  bool isServiceStarted();

  // Driver only accessors
  bool startDriver();
  bool stopDriver();
  bool restartDriver();

 private:
  int systemType;
  bool startStopService(char *command);
  MgeUtils pspUtils;
};

#endif
