// A class to provide supported models graphics. 
/**
 * This class provides information about supported models graphics 
 *
 * @author Arnaud Quette <arnaud.quette@mgeups.com>
 * @version 2005/02/14 Creation
 *
 * Copyright (C) 2005 by MGE UPS SYSTEMS
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2.
 *  Please, read the COPYING file provided with this software for the full text
 */

#ifndef _MODELS_HH
//#  include <glibmm.h>
#  define _MODELS_HH

#include <string>

// Models structure and images
typedef struct upsGfx {
  std::string upsName;
  std::string gfxName;
} upsGfx;

static upsGfx upsImages[] =
{
  // Ellipse models
  { "ellipse 300", "models/ellipse.png" },
  { "ellipse 500", "models/ellipse.png" },
  { "ellipse 650", "models/ellipse.png" },
  { "ellipse 800", "models/ellipse.png" },
  { "ellipse 1200", "models/ellipse.png" },

  // Ellipse Premium models
  { "ellipse premium 500", "models/ellipsep.png" },
  { "ellipse premium 650", "models/ellipsep.png" },
  { "ellipse premium 800", "models/ellipsep.png" },
  { "ellipse premium 1200", "models/ellipsep.png" },

  // Ellipse "Pro"
  { "Ellipse 600", "models/ellipseoffice.png" },
  { "Ellipse 750", "models/ellipseoffice.png" },
  { "Ellipse 1000", "models/ellipseoffice.png" },
  { "Ellipse 1500", "models/ellipseoffice.png" },

  /* Ellipse MAX */
  { "Ellipse MAX 600", "models/ellipsemax.png" },
  { "Ellipse MAX 850", "models/ellipsemax.png" },
  { "Ellipse MAX 1100", "models/ellipsemax.png" },
  { "Ellipse MAX 1500", "models/ellipsemax.png" },
	  
  // Jaguar models
  { "Pulsar Evolution 500", "models/evolution1.png" },
  { "Pulsar Evolution 800", "models/evolution1.png" },
  { "Pulsar Evolution 1100", "models/evolution1.png" },
  // FIXME: should be removed once fixed in NUT
  { "evolution 500", "models/evolution1.png" },
  { "evolution 800", "models/evolution1.png" },
  { "evolution 1100", "models/evolution1.png" },

  // Cougar models
  { "Pulsar Evolution 1500", "models/evolution2.png" },
  { "Pulsar Evolution 2200", "models/evolution2.png" },
  { "Pulsar Evolution 3000", "models/evolution2.png" },
  { "Pulsar Evolution 3000 XL", "models/evolution2.png" },
  // FIXME: should be removed once fixed in NUT
  { "evolution 1500", "models/evolution2.png" },
  { "evolution 2200", "models/evolution2.png" },
  { "evolution 3000", "models/evolution2.png" },
  { "evolution 3000 XL", "models/evolution2.png" },

  // Protection Center
  { "Protection Center 420", "models/protcenter.png" },
  { "Protection Center 500", "models/protcenter.png" },
  { "Protection Center 675", "models/protcenter.png" },

  // Protection Station - Pegasus
  { "Protection Station 500", "models/protstation.png" },
  { "Protection Station 650", "models/protstation.png" },
  { "Protection Station 800", "models/protstation.png" },
  
  // NOVA
  { "NOVA 600 AVR", "models/nova.png" },
  { "Nova AVR 625", "models/nova.png" },
  { "NOVA 1100 AVR", "models/nova.png" },
  { "Nova AVR 1250", "models/nova.png" },

  // ES+
  { "Pulsar ES2+", "models/esv5.png" },
  { "Pulsar ES5+", "models/esv5.png" },
  // FIXME: should be removed once fixed in NUT
  { "Pulsar ES 2+", "models/esv5.png" },
  { "Pulsar ES 5+", "models/esv5.png" },

  // ESV+
  { "Pulsar ESV5+", "models/esv5.png" },
  { "Pulsar ESV8+", "models/esv8.png" },
  { "Pulsar ESV11+", "models/esv8.png" },
  { "Pulsar ESV14+", "models/esv8.png" },
  { "Pulsar ESV22+", "models/esv8.png" },
  // FIXME: should be removed once fixed in NUT
  { "Pulsar ESV 5+", "models/esv5.png" },
  { "Pulsar ESV 8+", "models/esv8.png" },
  { "Pulsar ESV 11+", "models/esv8.png" },
  { "Pulsar ESV 14+", "models/esv8.png" },
  { "Pulsar ESV 22+", "models/esv8.png" },

  // Pulsar EX
  { "Pulsar EX7", "models/ex0710.png" },
  { "Pulsar EX10", "models/ex1540.png" },
  { "Pulsar EX15", "models/ex1540.png" },
  { "Pulsar EX20", "models/ex1540.png" },
  { "Pulsar EX30", "models/ex1540.png" },
  { "Pulsar EX40", "models/ex1540.png" },
  // FIXME: should be removed once fixed in NUT
  { "Pulsar EX 7", "models/ex0710.png" },
  { "Pulsar EX 10", "models/ex1540.png" },
  { "Pulsar EX 15", "models/ex1540.png" },
  { "Pulsar EX 20", "models/ex1540.png" },
  { "Pulsar EX 30", "models/ex1540.png" },
  { "Pulsar EX 40", "models/ex1540.png" },

  // EXtreme C (EMEA)
  { "Pulsar EXtreme 700C", "models/extremec.png" },
  { "Pulsar EXtreme 1000C", "models/extremec.png" },
  { "Pulsar EXtreme 1500C", "models/extremec.png" },
  { "Pulsar EXtreme 1500C CLA", "models/extremec.png" },
  { "Pulsar EXtreme 2200C", "models/extremecrt.png" },
  { "Pulsar EXtreme 3200C", "models/extremecrt.png" },
  // EXtreme C (USA, aka "EX RT")
  { "Pulsar EX 700 RT", "models/extremecrt.png" },
  { "Pulsar EX 1000 RT", "models/extremecrt.png" },
  { "Pulsar EX 1500 RT", "models/extremecrt.png" },
  { "Pulsar EX 2200 RT", "models/extremecrt.png" },
  { "Pulsar EX 3200 RT", "models/extremecrt.png" },

  // Pulsar EXtreme
  { "Pulsar EXtreme 1500", "models/pulsarextreme.png" },
  { "Pulsar EXtreme 2000", "models/pulsarextreme.png" },
  { "Pulsar EXtreme 2500", "models/pulsarextreme.png" },
  { "Pulsar EXtreme 3000", "models/pulsarextreme.png" },
  // FIXME: should be removed once fixed in NUT
  { "EXtreme 1500", "models/pulsarextreme.png" },
  { "EXtreme 2000", "models/pulsarextreme.png" },
  { "EXtreme 2500", "models/pulsarextreme.png" },
  { "EXtreme 3000", "models/pulsarextreme.png" },

  // Comet
  { "Comet 5", "models/comet.png" },
  { "Comet 7.5", "models/comet.png" },
  { "Comet 10", "models/comet.png" },
  { "Comet 15", "models/comet.png" },
  { "Comet 20", "models/comet.png" },
  { "Comet 30", "models/comet.png" },
  { "Comet 12", "models/comet.png" },
  { "Comet 18", "models/comet.png" },
  { "Comet 24", "models/comet.png" },
  { "Comet 36", "models/comet.png" },

  // Comet EXtreme
  { "Comet EXtreme 4.5", "models/cometextreme.png" },
  { "Comet EXtreme 6", "models/cometextreme.png" },
  { "Comet EXtreme 9", "models/cometextreme.png" },
  { "Comet EXtreme 12", "models/cometextreme.png" },

  // Comet EX RT 1:1
  { "EX 5 RT", "models/exrt.png" },
  { "EX 7 RT", "models/exrt.png" },
  { "EX 11 RT", "models/exrt.png" },
  // Comet EX RT 3:1
  { "EX 5 RT 3:1", "models/exrt.png" },
  { "EX 7 RT 3:1", "models/exrt.png" },
  { "EX 11 RT 3:1", "models/exrt.png" },

  // Pulsar EXL
  { "Pulsar EXL 5.0", "models/comet.png" },
  { "Pulsar EXL 7.0", "models/comet.png" },
  { "Pulsar EXL 10", "models/comet.png" },

  // Comet
  { "Comet 5", "models/comet.png" },
  { "Comet 7.5", "models/comet.png" },
  { "Comet 10", "models/comet.png" },
  { "Comet 15", "models/comet.png" },
  { "Comet 20", "models/comet.png" },
  { "Comet 30", "models/comet.png" },
  { "Comet 12", "models/comet.png" },
  { "Comet 18", "models/comet.png" },
  { "Comet 24", "models/comet.png" },
  { "Comet 36", "models/comet.png" },

  // Galaxy 3000
  { "Galaxy 3000 10 kVA", "models/galaxy3k.png" },
  { "Galaxy 3000 15 kVA", "models/galaxy3k.png" },
  { "Galaxy 3000 20 kVA", "models/galaxy3k.png" },
  { "Galaxy 3000 30 kVA", "models/galaxy3k.png" },

  // Galaxy 4000
  { "Galaxy 4000 40 kVA", "models/galaxy4k.png" },
  { "Galaxy 4000 50 kVA", "models/galaxy4k.png" },
  { "Galaxy 4000 65 kVA", "models/galaxy4k.png" },
  { "Galaxy 4000 80 kVA", "models/galaxy4k.png" },

  // Galaxy PW
  { "Galaxy PW On Line", "models/galaxypw.png" },
  { "Galaxy PW Eco", "models/galaxypw.png" },
  { "Galaxy PW Single //", "models/galaxypw.png" },

  // Galaxy 5000
  { "Galaxy 5000 40 kVA", "models/galaxy5k.png" },
  { "Galaxy 5000 60 kVA", "models/galaxy5k.png" },
  { "Galaxy 5000 80 kVA", "models/galaxy5k.png" },
  { "Galaxy 5000 100 kVA", "models/galaxy5k.png" },
  { "Galaxy 5000 120 kVA", "models/galaxy5k.png" },

	// Kept for backward compatibility
	// Pulsar M
	{ "Pulsar M 2200", "models/pulsar-m3000.png" },
	{ "Pulsar M 3000", "models/pulsar-m3000.png" },
	{ "Pulsar M 3000 XL", "models/pulsar-m3000.png" },
	// Pulsar
	{ "Pulsar 700", "models/pulsar.png" },
	{ "Pulsar 1000", "models/pulsar.png" },
	{ "Pulsar 1500", "models/pulsar.png" },
	// Pulsar RT
	{ "Pulsar 1000 RT2U", "models/pulsar1500.png" },
	{ "Pulsar 1500 RT2U", "models/pulsar1500.png" },

	// Eaton'ified versions
	// Pulsar M
	{ "EX 2200", "models/pulsar-m3000.png" },
	{ "EX 3000", "models/pulsar-m3000.png" },
	{ "EX 3000 XL", "models/pulsar-m3000.png" },
	// Pulsar
	{ "EX 700", "models/pulsar.png" },
	{ "EX 1000", "models/pulsar.png" },
	{ "EX 1500", "models/pulsar.png" },
	// Pulsar RT
	{ "EX 1000 RT2U", "models/pulsar1500.png" },
	{ "EX 1500 RT2U", "models/pulsar1500.png" },

	// Pulsar MX RT
	{ "Pulsar MX 4000 RT", "models/pulsar-mx.png" },
	{ "Pulsar MX 5000 RT", "models/pulsar-mx.png" },

	// newer Evolution
	{ "Evolution 650", "models/evolution3.png" },
	{ "Evolution 850", "models/evolution3.png" },
	{ "Evolution 1150", "models/evolution3.png" },
	{ "Evolution 1550", "models/evolution3.png" },
	{ "Evolution S 1250", "models/evolution4.png" },
	{ "Evolution S 1750", "models/evolution4.png" },
	{ "Evolution 2000", "models/evolution4.png" },
	{ "Evolution S 2500", "models/evolution4.png" },
	{ "Evolution S 3000", "models/evolution4.png" },

  // FIXME: miss
  // - galaxy
  // - Esprit
  // - SV, ESV
  // - SX, PSX, CSX
  // - HP, Meta, Protocol Interface

  // Generic model icon for unmanaged/unrecognised models
  { "null", "models/generic.png" } 	
};

#endif
