// generated 2004/11/18 10:30:30 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to mnc.cc_new

// This file is for your program, I won't touch it again!

#include <config.h>
#include <gtkmm/main.h>
#include <glib/gi18n.h>
#include <fstream>
#include <glibmm.h>
#include <gdkmm.h>
#include <pangomm.h> // FIXME: needed there????
#include <string.h>

#include "splashwin.hh"
#include "MainWindow.hh"
#include "MgeUtils.h"

#include <getopt.h>  // FIXME: to be removed with Glib::OptionContext
#include <signal.h>  // FIXME: to be removed when??

#include "tool.h"
#include "view.h"
class NutClient;

#include "dlgInfo.hh"
#include "dlgInfoOPS.hh"

// FIXME: not clean!
MgeUtils *pspUtils;
NutConfig *nutConfig;
Glib::ustring *pspCmd;
// same for cmdLine
bool startHidden;
bool autoConfigure;
bool debugFlag = false;
Glib::ustring *cliDriver;
Glib::ustring *cliPort;
Glib::ustring *cliView;
Glib::ustring *cliCommandLine;

ofstream traceFile;

// Hack to handle QUIT/STOP signal
void sigHandler(int signal)
{
  // Hide systray to allow exit
  mainWinPtr->nutDlg->sysTray->setVisibility (false);
  mainWinPtr->gtk_main_quit();
}

// FIXME: put apart
// MGE Command Line Interface Option Group
// --start-hidden
// --auto-configure --driver=x --port=y
// --settings: launch (in AdminMode) with setView(config || settings)
void parseCommandLine(int argc, char **argv)
{
  char *cmdline, *p;
  int  i, c;

  // values default init
  autoConfigure = false;
  startHidden = false;
  cliDriver = new Glib::ustring();
  cliPort = new Glib::ustring();
  cliView = new Glib::ustring();
  cliCommandLine = new Glib::ustring(*pspCmd);

  while(1)
	{
	  static struct option long_options[] =
		{
		  {"auto-configure", required_argument, NULL, 'a'}, // require driver,port
		  {"debug", no_argument, NULL, 'd'},
		  {"help", no_argument, NULL, 'h'},
		  {"start-hidden", no_argument, NULL, 's'},
		  {"view", required_argument, NULL, 'v'},
		  {0, 0, 0, 0}
		};
	  if ((c = getopt_long(argc, argv, "a:v:dhs", long_options, NULL)) == -1)
		break;
	  
	  switch (c)
		{
		case 'a':
		  autoConfigure = true;

		  p = strchr(optarg, ',');
		  if (p != NULL)
			*p = '\0';
		  else
			{
			  std::cerr << "Option auto-configure requires a driver and a port name." << std::endl;
			  autoConfigure = false;
			  break;
			}

		  cliDriver->assign(optarg);
		  cliPort->assign(p+1);
		  std::cout << "Option auto-configure: cliDriver = " << cliDriver->raw();
		  std::cout << ", cliPort = " << cliPort->raw() << std::endl;
		  cliCommandLine->append(" -a ");
		  cliCommandLine->append(*cliDriver);
		  cliCommandLine->append(",");
		  cliCommandLine->append(*cliPort);
		  break;
		case 'd':
		  std::cout << "option debug" << std::endl;
		  debugFlag = true;
		  cliCommandLine->append(" -d ");
		  break;
		case 's': 
		  std::cout << "option start-hidden" << std::endl;
		  startHidden = true;
		  cliCommandLine->append(" -s ");
		  break;
		case 'v':
		  std::cout << "option view: value " << optarg << std::endl;
		  cliView->assign(optarg);
		  cliCommandLine->append(" -v ");
		  cliCommandLine->append(*cliView);
		  break;
		case 'h':
		default:  
		  std::cout << "\n" << PACKAGE << " version: " VERSION << "\n" << std::endl;
		  std::cout << "Usage: psp [arguments]\n" << std::endl;
		  std::cout << "-a <driver,port> Auto configure PSP with the following:" << std::endl;
		  std::cout << "\t\t driver is the driver name (mge-shut, mge-utalk or newhidups)." << std::endl; 
		  std::cout << "\t\t port is the port name (/dev/ttyS0, ... or auto for newhidups)." << std::endl;
		  std::cout << "-h\t\t Display the current help." << std::endl;		  
		  std::cout << "-s\t\t Start hidding the main interface." << std::endl;
		  std::cout << "\t\t If system tray is configured as hidden, PSP will exit." << std::endl;
		  std::cout << "-v <view>\t Start showing view (status, history, settings or about)." << std::endl << std::endl;

		  //pspUtils->destroyAppLock();
		  exit (1);
		}
	}
}

int main(int argc, char **argv)
{
  MainWindow *mainWin = NULL;
  splashwin *splashwin = NULL;
  //ofstream traceFile;
  int tries = 3;
  bool retCode = false;

  // Conditional i18n support
#if defined(ENABLE_NLS)
   bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
   bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
   textdomain (GETTEXT_PACKAGE);
#endif //ENABLE_NLS

	pspCmd = new Glib::ustring(argv[0]); // FIXME: any better way to keep selfpath?

//	if (pspUtils->getSystemType() == MgeUtils::SYSTEM_TYPE_MDK_2007) {
	if ( (pspUtils->getSystemType() == MgeUtils::SYSTEM_TYPE_MDK)
		|| (pspUtils->getSystemType() == MgeUtils::SYSTEM_TYPE_RHFC) ) {
		// for the consolehelper trick...
		pspCmd->append("-root");
	}

	// Command line options handling
	parseCommandLine(argc, argv);

	// multithreading init (if not already done)
	if (Glib::thread_supported () == false)
		Glib::thread_init();
	else
	{
		std::cout << "Thread are not supported. Exiting program..." << std::endl;
		return -1;
	}

	// Trace handling/redirection
	if (debugFlag == false)
	{
		// Trash stdout/stderr
		traceFile.open("/dev/null");
		if (traceFile.is_open())
		{
			cout.rdbuf(traceFile.rdbuf());
			cerr.rdbuf(traceFile.rdbuf());
		}
		else
		{
			if (traceFile.fail())
				std::cout << "Failed to redirect trace to /dev/null" << std::endl;
		}
	}

   // Application creation...
   Gtk::Main m(&argc, &argv);
   
   std::cout << "App PID is: " << getpid() << std::endl;

   // ... Object instanciation
   pspUtils = new class MgeUtils();
   nutConfig = new class NutConfig();

   // Check for PSP prev-instance
   if (pspUtils->checkPrevInstance() == false)
	 {
	   if ((nutConfig->getDisplaySystray() == false) && (startHidden==true))
		 {
		   std::cout << "No need to be launched (systray hidden + --start-hidden option)" << std::endl;
		   pspUtils->destroyAppLock();
		   exit(1);
		 }

	   // FIXME: handle through some sigc (?) API
	   signal(SIGINT, sigHandler);
	   signal(SIGQUIT, sigHandler);
	   signal(SIGTERM, sigHandler);

	   // Check if it's the initial startup _or_ if we're autoconfiguring,
	   // _and_ if root rights are needed
	   if ( ((Glib::get_user_name ()).compare("root") != 0)
			&& ( (nutConfig->isNutConfigured() == false) 
				 || (autoConfigure==true) ) )
		 {
		   // FIXME: call gksu! with **argv to keep arguments
		   //if (pspUtils->switchToRoot(pspCmd) == false) // FIXME: retry!

		   // Start in hidden mode
		   cliCommandLine->append(" -s ");

		   while ( (retCode == false) && (tries > 0) )
			 {
			   tries --;
			   retCode = pspUtils->switchToRoot(cliCommandLine);

			   if (retCode == false)
				  std::cout << "FAILED TO SWITCH TO ROOT!!" << std::endl;
			 }

		   //	   mainWin->gtk_main_quit();
		   pspUtils->destroyAppLock();
		   exit(1);
		 }
 
	   // Hide mainwin for initial startup
	   if (nutConfig->isNutConfigured() == false)
			 startHidden = true;

	   // ... main window
	   if (cliView->empty () == false)
		 	mainWin = new class MainWindow(nutConfig, cliView->c_str(), ((startHidden==true)?false:true));
	   else
		 	mainWin = new class MainWindow(nutConfig, "status", ((startHidden==true)?false:true));

	   // Check for autoconfiguration before splashin'
	   if (autoConfigure==true)
		 {
		   // FIXME: improve this
		   nutConfig->setDriverType(cliDriver);
		   nutConfig->setCommunicationPort(cliPort);
		   nutConfig->setIsNutConfigured(true);
		   nutConfig->dumpConfiguration();
		 }

	   // ... splash window
	   splashwin = new class splashwin();

	   // Create the data refresh thread
	   Glib::StaticRWLock rw_lock = GLIBMM_STATIC_RW_LOCK_INIT;
	   mainWin->nutDlg->nutClient->createLock(&rw_lock);
   
	   //   splashwin->show();

	   // Refresh the config View after initial configuration
	   nutConfig->readConfiguration();
	   mainWin->configDlg->restoreConfig();

		 // Show the MGE OPS warning only for PSP 3.0.5 and if there's no
		 // ~/.mgeops-psp.info flag existing
		 Glib::ustring *pkgVersion = new Glib::ustring(VERSION);
		 Glib::ustring *infoFileName = new Glib::ustring(Glib::get_home_dir () + "/.mgeops-psp.info");
	   if ( (pkgVersion->compare("3.0.5") == 0)
	   		&& (Glib::file_test (*infoFileName, Glib::FILE_TEST_EXISTS) == false) )
		 {
				dlgInfoOPS *infoOPSDlg = new dlgInfoOPS();
		 }
	   m.run();
	 }
   else
	 {
	   //mainWin = new class MainWindow(nutConfig, "status", false);

	   // There's already an instance running
	   std::cout << "There is already an instance running of PSP. Exiting program..." << std::endl;
	   dlgInfo *myDlg = new dlgInfo(_("There is already an instance\nof PSP running."), "warning48.png", true);

	   // run (and quit directly by side effect)
	   m.run();
	 }

   // Final windows deletion
   if (mainWin != NULL)
	 	delete mainWin;

   if (splashwin != NULL)
	 	delete splashwin;

   if ( (debugFlag == false) && (traceFile.is_open()) )
	 {
	   // Flush buffer and exit
	   traceFile.flush();
	   traceFile.close();
	 }

   exit(1);
}
