// generated 2004/12/6 10:26:11 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to splashwin.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "gettext.h"
#include "splashwin.hh"

//#include "main_window.hh"
#include "MainWindow.hh"
#include "SystemService.h"
#include "view.h"

#include <iostream>
#include <sstream>
#include <string>

#include "dlgInfo.hh"

splashwin *splashWinPtr;
SigC::Connection handle1, handle2;

int callFinalize()
{
  splashWinPtr->finalize();
  handle1.disconnect();
  return 1;  
}

int propagateLowBattLevel()
{
//return 1; // seems to override the wizard.cfg value!

//  std::cout << "LOWBATT-CFG = "<< mainWinPtr->nutDlg->nutClient->batteryLowCharge << std::endl;
//  mainWinPtr->configDlg->nutConfig->setShutdownBatteryLevel(mainWinPtr->nutDlg->nutClient->batteryLowCharge);

  std::cout << "LOWBATT-CFG (nutConfig) = "<< mainWinPtr->configDlg->nutConfig->getShutdownBatteryLevel() << std::endl;
std::cout << "LOWBATT-CFG (nutClient) = "<< mainWinPtr->nutDlg->nutClient->batteryLowCharge << std::endl;
	mainWinPtr->configDlg->nutConfig->setShutdownBatteryLevel(mainWinPtr->configDlg->nutConfig->getShutdownBatteryLevel());

  mainWinPtr->configDlg->refreshView();
  mainWinPtr->configDlg->nutConfig->dumpPspConfiguration();

  handle2.disconnect();
  return 1;  
}

// Generic view refresh callback (will only call the currently displayed one)
int refreshView()
{ 
  std::cout << "=>Refreshing view: " << mainWinPtr->getCurrentViewName() << std::endl;

  mainWinPtr->refreshView();

  return 1;
}

splashwin::splashwin()
{
  splashWinPtr = this;

  // FIXME: buggy startup sequence
  //   if (mainWinPtr->configDlg->nutConfig->isNutConfigured() == false)
  // 	this->show();
  this->hide();

  // Delayed call to finalize (post display)
  handle1 = Glib::signal_timeout().connect(sigc::ptr_fun(&callFinalize), 500);
}

void splashwin::finalize()
{
  int retCode, retry;
  Glib::ustring* comPort = new Glib::ustring();
  std::ostringstream oss; 
  std::string tmpString;
  bool firstTimeCfg = false;

  //oss << lblsplash->get_text() << "\n\n";

  // Check if configuration has already been done
  if (mainWinPtr->configDlg->nutConfig->isNutConfigured() == false)
	{

	  firstTimeCfg = true;
	  
	  // Probe UPS
	  oss.str("");
	  oss << _("Please wait until your UPS is detected.");
	  lblsplash->set_text(oss.str());
	  this->show();
	  lblsplash->show();
	  //  Glib::usleep(2000000); // sleep 5 sec
	  while( Gtk::Main::events_pending() )
		Gtk::Main::iteration();
	  
	  Glib::usleep(200000);
// 		Gtk::Main::iteration(true);		
// 		Gtk::Main::iteration(true);

		std::cout << oss.str() << std::endl;

		retCode = mainWinPtr->nutDlg->nutClient->probeUPS(comPort);

		oss.str("");

		switch(retCode)
		  {
		  case 1:
			oss << _("Found an USB UPS\n");
			break;
		  case 2:
		  case 3:
			oss << _("Found a serial UPS (port: ") << comPort->data() << ")\n";
			break;
		  default:
		  case 0:
			oss << _("No UPS found\n");
			lblsplash->set_text(oss.str());
			std::cout << oss.str() << std::endl;
			Gtk::Main::iteration(true);
			Glib::usleep(2000000);
			// Set to hidden mode to allow quit
			mainWinPtr->nutDlg->sysTray->setVisibility (false);
			this->hide();
			dlgInfo *myDlg = new dlgInfo(_("No UPS found.\nCheck that your UPS USB or serial cord is plugged.\nIf you own an USB UPS, unplug and replug the USB cord, and relaunch the PSP."), "warning48.png", true);
			myDlg->show();
			return;
			break;
		  }
		std::cout << oss.str() << std::endl;
		  

		oss.str("");
		// FIXME: PSPWin to be corrected
		// oss << "Please wait until the module of protection is started.";
		oss << _("Please wait while the protection module is started.");
		lblsplash->set_text(oss.str());
		lblsplash->show();
		while( Gtk::Main::events_pending() )
		  Gtk::Main::iteration();
		//		Gtk::Main::iteration(true);		
		//		Gtk::Main::iteration(true);
		Glib::usleep(200000); 

		// Store probe values
		oss.str("");
		oss << "\nStoring NUT configuration...\n";
		std::cout << oss.str() << std::endl;

	} // isNutConfigured()

	SystemService *nutService = new SystemService();

	if (firstTimeCfg == true)
	  {
		// Stop services before dumping configuration files
		if (nutService->isServiceStarted() == true)
		  {
			if (nutService->stopService() == false)
			  std::cout << "Failed to stop NUT services" << std::endl;
			else
			  std::cout << "NUT services stopped successfully" << std::endl;
		  }
		  else
			std::cout << "NUT Services are not started" << std::endl;

		// Dump the configuration files
		//mainWinPtr->configDlg->nutConfig = new NutConfig (retCode, comPort);
		mainWinPtr->configDlg->nutConfig->setDriverType(retCode);
		mainWinPtr->configDlg->nutConfig->setCommunicationPort(comPort);

		// Only set the isNutConfigured flag is the device was detected
		if (mainWinPtr->configDlg->nutConfig->getDriverType() != UPS_TYPE_NONE)
		  mainWinPtr->configDlg->nutConfig->setIsNutConfigured(true);
		mainWinPtr->configDlg->nutConfig->dumpConfiguration();

		// (Re)start NUT services
		if (nutService->startService() == false)
		  std::cout << "Failed to restart NUT services" << std::endl;
		else
		  std::cout << "NUT services restarted successfully" << std::endl;

		// Test data availability (3 tries)
		for (retry = 5; retry > 0; retry--)
		  {
			std::cout << "Testing driver reachability" << std::endl;

			retCode = mainWinPtr->nutDlg->nutClient->getVar("ups.status", &tmpString);
			
			if (retCode < 0)
			  {
				std::cout << "Driver not reachable (" << retCode << ")" << std::endl;

				if (retCode == UPSCLI_ERR_DRVNOTCONN)
				  {
					std::cout << "Driver seems to have failed starting. Trying to restart it..." << std::endl;
					// FIXME: enhance the watchdog and restart procedure
					nutService->restartDriver();
				  }
				else
				  continue;
			  }
			else
			  {
				std::cout << "Driver is now reachable" << std::endl;
				break;
			  }
			Glib::usleep(2000000); // sleep for 2 seconds
		  }
	  } 
	else
	  {

		if (nutService->isServiceStarted() == false)
		  {
			std::cout << "NUT services aren't started" << std::endl;

			if (nutService->startService() == false)
			  std::cout << "Failed to start NUT services" << std::endl;
			else
			  std::cout << "NUT services started successfully" << std::endl;
		  } // else: nothing to do, we're in nominal mode
	  }

	delete nutService;

  //////////////////////////////////////////////////////////////////////////////
  std::cout << "Finalizing init..." << std::endl;

  
  mainWinPtr->nutDlg->nutClient->refreshDataThread = Glib::Thread::create(sigc::mem_fun(mainWinPtr->nutDlg->nutClient, &NutClient::refreshVars), false);

  // Connect the refresh view routine, called every second
  Glib::signal_timeout().connect(sigc::ptr_fun(&refreshView), 1000);

  // hide splash screen
  this->hide();

  // Display main_window
  if ( (mainWinPtr->getVisibility() == true)
	   || (firstTimeCfg == true) )
	mainWinPtr->setVisibility (true);

  // Ugly hack to retrieve the UPS internal batt.charge.low which
  // need nut to be configured/running
  // Delayed call (10 sec)
  handle2 = Glib::signal_timeout().connect(sigc::ptr_fun(&propagateLowBattLevel), 10000);
}
